#ifndef UNDOPAINTER_H
#define UNDOPAINTER_H

#include <qarray.h>

#include "constants.h"
#include "sketchpainter.h"
#include "ptpen.h"

class pen_stroke {
 public:
  PtPen pen;
  int x0, x1, y0, y1;
};


class UndoPainter : public SketchPainter {
  pen_stroke *stroke_que;
  pen_stroke *temp_que;
  uint stroke_index, temp_index, inter_index;

 public:
  UndoPainter(int, int);
  ~UndoPainter(void);

  void changePainter(SketchPainter *);

  void enque(const pen_stroke&);
  void enque(const PtPen&, int, int, int, int);
  void enquePenUp(void);

  void getBuffer(uint16 *, uint);
  void fixStroke(void);

 private:
  void apply_stroke(pen_stroke &);
};

#endif // UNDOPAINTER_H
